%!TEX root=../../../../thesis.tex
%!TEX file=content/appendix/root-finding/iterative/newtons-method.tex

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection{Newton's Method}\label{app:sec:root-finding:newton}

The most often used numerical root-finding algorithm is Newton's method~(or Newton-Raphson), which finds successively better approximations to the roots of a real-valued scalar or vector function~$f \of{\itervar*}$ or~$\vect{f} \of{\itervar}$, respectively.
We present Newton's method for the scalar-valued case, but it can be extended to the vector-valued case in a straightforward manner.

Let~$f \colon \interval{a}{b} \to \mathds{R}$ be a smooth scalar function defined on interval~$\interval{a}{b}$.
To use Newton's method, one starts with an initial guess~$\itervar*_{0}$ in close proximity to the actual root~$\actual{\itervar*}$.
Then, we can perform linearization of~$f$ around~$\actual{\itervar*}$ giving us
%
\begin{align*}
  f \of{ \itervar*_{0} = \actual{\itervar*} + \iterstep* }
    & = f \of{ \actual{\itervar*} }
        + f^{\prime} \of{ \actual{\itervar*} } \, \iterstep* \,
\end{align*}
%
The function is thus approximated by its tangent, for which the~$\itervar*$-intercept of the tangent is calculated
%
\begin{align*}
  y = 0
    & = f^{\prime} \of{ \itervar*_{\iterindex} } \,
        \parentheses{
          \actual{\itervar*} - \itervar*_{\iterindex}
        }
        +
        f \of{ \itervar*_{\iterindex} }
\end{align*}
%
typically providing a better approximation to the function's root.
This iteration process is then repeated until certain termination conditions are met.
We can rewrite the iterative algorithm to yield the next approximate of the root~$\itervar*_{\iterindex + 1}$.

Newton's method can be directly extended to higher dimensions for either~$\itervar \in \mathds{R}^{m}$ with $\vect{f} \of{ \itervar* } \colon \mathds{R} \to \mathds{R}^{n}$ or~$\vect{f} \of{\itervar} \colon \mathds{R}^{n} \to \mathds{R}^{m}$ by using the Jacobian of~$\vect{f} \of{\itervar}$ at~$\itervar_{\iterindex}$ yielding
%
\begin{align*}
  \iterstep
    & = \inv{
          \jacobian{\vect{f}}
        } \of{ \itervar_{\iterindex} } \,
        \vect{f} \of{ \itervar_{\iterindex} } \,
        ,
    \\
  \itervar_{\iterindex + 1}
    & = \itervar_{\iterindex} - \iterstep \,
      .
\end{align*}

Stopping criteria for Newton's method are simply given through either a small {residual~$\norm{ \vect{f} \of{ \itervar*_{\iterindex} } } \leq \threshold_{ \ms{res} }$}, small {step size~$\norm{ \iterstep } \leq \threshold_{\Delta}$}, or exceeded {iteration count~$\iterindex > \iterindex_{ \ms{max} }$}.



